# ShadingOut Struct Reference
[Data Structures]

Inheritance diagram for ShadingOut:

List of all members.

## Public Member Functions
void | SetDefaultValues ()
void | Clear ()
| ShadingOut ()
boolean | CheckDefaultValues ()
ShadingOut & | operator+= (ShadingOut &)
ShadingOut & | operator-= (ShadingOut &)
ShadingOut & | operator*= (real)
## Public Attributes
TMCColorRGBA | fColor
| Diffuse Color (Kd).
TMCColorRGB | fSpecularColor
| Specular Color (Ks).
real | fSpecularSize
| Specular highlight size (Ns).
real | fAmbient
| Ambient factor (Fa).
real | fLambert
| Diffuse factor (Fd).
real | fRefractiveIndex
| Refraction index (Nr).
TMCColorRGB | fGlow
| Glow color.
TVector3 | fChangedNormal
| Changed Normal in Global Coordinates (not evaluated by the shader!).
real | fLayerMask
| Used in Layer List only !
TTransparencyParameters | fTransparency
| Transparency (Tx).
TReflectionParameters | fReflection
| Reflection.
TSubsurfaceParameters | fSubsurfaceScattering
| Subsurface scattering.
TMCColorRGB | fTranslucency
boolean | fFullAreaDone
| true if the shader was evaluated on the area
TVector3 | fChangedNormalLoc
| Changed Normal in Local Coordinates (calculated by the shader).

## Detailed Description

Specifies the shading of a given point

Here is how the specular color is computed from the light and shading:

     real Ns=(0.001f+fSpecularSize*fSpecularSize)*kSpecularPowerCoef;
     specColorCoef= 2*RealPow(reflectDir*lightDirection, Ns);
     specColor+= fSpecularColor * lightColor * specColorCoef;

## Constructor & Destructor Documentation

ShadingOut::ShadingOut | ( |  | ) | `[inline]`

## Member Function Documentation

boolean ShadingOut::CheckDefaultValues | ( |  | ) | `[inline]`

void ShadingOut::Clear | ( |  | ) | `[inline]`

ShadingOut & ShadingOut::operator*= | ( | real | t | ) | `[inline]`

ShadingOut & ShadingOut::operator+= | ( | ShadingOut & | s | ) | `[inline]`

ShadingOut & ShadingOut::operator-= | ( | ShadingOut & | s | ) | `[inline]`

void ShadingOut::SetDefaultValues | ( |  | ) | `[inline]`

## Member Data Documentation

real ShadingOut::fAmbient

Ambient factor (Fa).

TVector3 ShadingOut::fChangedNormal

Changed Normal in Global Coordinates (not evaluated by the shader!).

TVector3 ShadingOut::fChangedNormalLoc

Changed Normal in Local Coordinates (calculated by the shader).

TMCColorRGBA ShadingOut::fColor

Diffuse Color (Kd).

boolean ShadingOut::fFullAreaDone

true if the shader was evaluated on the area

TMCColorRGB ShadingOut::fGlow

Glow color.

real ShadingOut::fLambert

Diffuse factor (Fd).

real ShadingOut::fLayerMask

Used in Layer List only !

TReflectionParameters ShadingOut::fReflection

Reflection.

real ShadingOut::fRefractiveIndex

Refraction index (Nr).

TMCColorRGB ShadingOut::fSpecularColor

Specular Color (Ks).

real ShadingOut::fSpecularSize

Specular highlight size (Ns).

TSubsurfaceParameters ShadingOut::fSubsurfaceScattering

Subsurface scattering.

TMCColorRGB ShadingOut::fTranslucency

TTransparencyParameters ShadingOut::fTransparency

Transparency (Tx).

The documentation for this struct was generated from the following file:

- ShaderTypes.h